#!/usr/bin/env python
from pydub import AudioSegment


# EDIT THESE SO THEY POINT TO THE RIGHT DIRECTORY AND FILES

wav_directory = 'wavsongs/'
mp3_directory = 'songs/'
in_csv = 'clip_info_final.csv'

# WILL CONTAIN INFO ON ALL CLIPS THAT HAVE BEEN SUCCESFULLY CONVERTED TO WAV FILES

out_csv = 'clip_info_out.csv'


try:
	fin = open(in_csv)
	fout = open(out_csv, 'w')
except:
	print('Could not open {} or {}'.format(in_csv, out_csv))
	exit()

h = fin.readline()
fout.write(h)

for line in fin:
	words = line.split('\t')
	path = words[9].strip('"\r\n')
	if(len(path) > 0):
		mp3_path = mp3_directory + path
		try:
			wav_file = path[:len(path)-3] + "wav"
			wav_path = wav_directory + wav_file
			mp3 = AudioSegment.from_mp3(mp3_path)
			mp3.export(wav_path, format='wav')
			print("COULD CONVERT TO: " + wav_path)
			fout.write(line.replace('.mp3', '.wav'))
		except:
			print("COULD NOT OPEN: " + mp3_path)

fout.close()
fin.close()