#!/usr/bin/env python

from collections import defaultdict
import math
import scipy as sp

# EDIT THIS TO POINT TO THE CSV FILE GENERATED BY convert.py
csv_in = 'clip_info_out.csv'

# EDIT THESE TO CHANGE THE OUTPUT FILE OF THE TRAIN AND TEST SET
csv_train = 'train.csv'
csv_test = 'test.csv'


try:
	fin = open(csv_in)
except:
	print('Could not open {}'.format(csv_in))
	exit()

try:
	train = open(csv_train, 'w')
except:
	print('Could not open {}'.format(csv_train))
	exit()


try:
	test = open(csv_test, 'w')
except:
	print('Could not open {}'.format(csv_test))
	exit()


t = fin.readline()

artists = defaultdict(int)
songs = defaultdict(list)
nrSongs = 0
nrTestSet = 2550

for line in fin:
	words = line.split('\t')
	artist = words[3].strip('"')
	if(artist == 'Magnatune Remixed'):
		continue
	elif(artist == 'Magnatune' or artist == 'Magnatune Compilation' or artist == 'Magnatune.com' or artist == 'Various Artists'):
		continue
	elif(artist == 'C. Layne'):
		artist = 'C Layne'
	elif(artist == 'Four Stones.Net'):
		artist = 'Four Stones'
	elif(artist == 'Philharmonia Baroque'):
		artist = 'Philharmonia Baroque Orchestra'

	artists[artist] += 1
	songs[artist].append(line)
	nrSongs += 1


print('Total artists: ' + str(len(artists)))

sorted_artists = list(artists.keys())
sorted_artists.sort()

for artist in sorted_artists:
	ptotest = artists[artist] / float(nrSongs)
	toTest = int(math.ceil(nrTestSet * ptotest))
	perm = sp.random.permutation(artists[artist])
	tests = perm[:toTest]
	trains = perm[toTest:]

	print(artist + ': ' + str(len(songs[artist])) + ', to test set: ' + str(toTest))
	for i in tests:
		line = songs[artist][i]
		words = line.split('\t')
		path = words[9].strip('"\r\n')
		title = words[2].strip('"')
		album = words[4].strip('"')
		tocsv = artist + '\t' + title + '\t' + album + '\t' + path + '\n'
		test.write(tocsv)

	for i in trains:
		line = songs[artist][i]
		words = line.split('\t')
		path = words[9].strip('"\r\n')
		title = words[2].strip('"')
		album = words[4].strip('"')
		
		tocsv = artist + '\t' + title + '\t' + album + '\t' + path + '\n'
		train.write(tocsv)
		
test.close()
train.close()
fin.close()
	
