#!/usr/bin/env python

from collections import defaultdict
import math
import scipy as sp
from random import shuffle

# EDIT THIS TO POINT TO THE CSV FILE GENERATED BY convert.py
csv_in = 'clip_info_out.csv'

# EDIT THESE TO CHANGE THE OUTPUT FILE OF THE TRAIN AND TEST SET
csv_train = 'train.csv'
csv_test = 'test.csv'


try:
	fin = open(csv_in)
except:
	print('Could not open {}'.format(csv_in))
	exit()

try:
	train = open(csv_train, 'w')
except:
	print('Could not open {}'.format(csv_train))
	exit()


try:
	test = open(csv_test, 'w')
except:
	print('Could not open {}'.format(csv_test))
	exit()

t = fin.readline()

artists = defaultdict(int)
clips = defaultdict(list)
songs = defaultdict(lambda: defaultdict(list))
nrclips = 0
nrTestSet = 1900

for line in fin:
	words = line.split('\t')
	artist = words[3].strip('"')
	title = words[2].strip('"')
	if(artist == 'Magnatune Remixed'):
		continue
	elif(artist == 'Magnatune' or artist == 'Magnatune Compilation' or artist == 'Magnatune.com' or artist == 'Various Artists'):
		continue
	elif(artist == 'C. Layne'):
		artist = 'C Layne'
	elif(artist == 'Four Stones.Net'):
		artist = 'Four Stones'
	elif(artist == 'Philharmonia Baroque'):
		artist = 'Philharmonia Baroque Orchestra'

	songs[artist][title].append(line)
	artists[artist] += 1
	clips[artist].append(line)
	nrclips += 1


print('Total artists: ' + str(len(artists)))

sorted_artists = list(artists.keys())
sorted_artists.sort()

tot_songs = 0

for artist in sorted_artists:
	tot_songs += len(songs[artist])
	print(artist + ': ' + str(len(songs[artist])))
	for song in songs[artist]:
		print('\t' + song + ': ' + str(len(songs[artist][song])))

for artist in sorted_artists:
	ptotest = artists[artist] / float(nrclips)
	toTest = int(math.ceil(nrTestSet * ptotest))
	
	artistSongs = list(songs[artist].keys())
	shuffle(artistSongs)
	
	writtenToTrain = 0
	for song in artistSongs:
		for clip in songs[artist][song]:
			words = clip.split('\t')
			path = words[9].strip('"\r\n')
			title = words[2].strip('"')
			album = words[4].strip('"')
			tocsv = artist + '\t' + title + '\t' + album + '\t' + path + '\n'
			
			if(toTest > 0):
				test.write(tocsv)
			else:
				train.write(tocsv)
				writtenToTrain += 1
				
		toTest -= len(songs[artist][song])
	
	if(writtenToTrain == 0):
		print(artist + ' Has no songs in training set')
	
	
	
	
